/* xnoise-db-creator.c generated by valac, the Vala compiler
 * generated from xnoise-db-creator.vala, do not modify */

/* xnoise-db-creator.vala
 *
 * Copyright (C) 2009-2010  Jörn Magens
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  The Xnoise authors hereby grant permission for non-GPL compatible
 *  GStreamer plugins to be used and distributed together with GStreamer
 *  and Xnoise. This permission is above and beyond the permissions granted
 *  by the GPL license by which Xnoise is covered. If you modify this code
 *  you may extend this exception to your version of the code, but you are not
 *  obligated to do so. If you do not wish to do so, delete this exception
 *  statement from your version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301  USA.
 *
 * Author:
 * 	Jörn Magens
 */

#include <glib.h>
#include <glib-object.h>
#include <sqlite3.h>
#include <gio/gio.h>
#include <stdlib.h>
#include <string.h>
#include <stdio.h>


#define XNOISE_TYPE_DB_CREATOR (xnoise_db_creator_get_type ())
#define XNOISE_DB_CREATOR(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), XNOISE_TYPE_DB_CREATOR, XnoiseDbCreator))
#define XNOISE_DB_CREATOR_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), XNOISE_TYPE_DB_CREATOR, XnoiseDbCreatorClass))
#define XNOISE_IS_DB_CREATOR(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), XNOISE_TYPE_DB_CREATOR))
#define XNOISE_IS_DB_CREATOR_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), XNOISE_TYPE_DB_CREATOR))
#define XNOISE_DB_CREATOR_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), XNOISE_TYPE_DB_CREATOR, XnoiseDbCreatorClass))

typedef struct _XnoiseDbCreator XnoiseDbCreator;
typedef struct _XnoiseDbCreatorClass XnoiseDbCreatorClass;
typedef struct _XnoiseDbCreatorPrivate XnoiseDbCreatorPrivate;
#define _sqlite3_close0(var) ((var == NULL) ? NULL : (var = (sqlite3_close (var), NULL)))

#define XNOISE_TYPE_GLOBAL_ACCESS (xnoise_global_access_get_type ())
#define XNOISE_GLOBAL_ACCESS(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), XNOISE_TYPE_GLOBAL_ACCESS, XnoiseGlobalAccess))
#define XNOISE_GLOBAL_ACCESS_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), XNOISE_TYPE_GLOBAL_ACCESS, XnoiseGlobalAccessClass))
#define XNOISE_IS_GLOBAL_ACCESS(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), XNOISE_TYPE_GLOBAL_ACCESS))
#define XNOISE_IS_GLOBAL_ACCESS_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), XNOISE_TYPE_GLOBAL_ACCESS))
#define XNOISE_GLOBAL_ACCESS_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), XNOISE_TYPE_GLOBAL_ACCESS, XnoiseGlobalAccessClass))

typedef struct _XnoiseGlobalAccess XnoiseGlobalAccess;
typedef struct _XnoiseGlobalAccessClass XnoiseGlobalAccessClass;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))

struct _XnoiseDbCreator {
	GObject parent_instance;
	XnoiseDbCreatorPrivate * priv;
};

struct _XnoiseDbCreatorClass {
	GObjectClass parent_class;
};

struct _XnoiseDbCreatorPrivate {
	sqlite3* db;
};

typedef enum  {
	XNOISE_DB_ERROR_FAILED
} XnoiseDbError;
#define XNOISE_DB_ERROR xnoise_db_error_quark ()

static GFile* xnoise_db_creator_xnoisedb;
static GFile* xnoise_db_creator_xnoisedb = NULL;
extern XnoiseGlobalAccess* xnoise_global;
static gpointer xnoise_db_creator_parent_class = NULL;

GType xnoise_db_creator_get_type (void);
#define XNOISE_DB_CREATOR_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), XNOISE_TYPE_DB_CREATOR, XnoiseDbCreatorPrivate))
enum  {
	XNOISE_DB_CREATOR_DUMMY_PROPERTY
};
#define XNOISE_DB_CREATOR_DATABASE_NAME "db.sqlite"
#define XNOISE_DB_CREATOR_SETTINGS_FOLDER ".xnoise"
#define XNOISE_DB_CREATOR_DB_VERSION_MAJOR 3
#define XNOISE_DB_CREATOR_DB_VERSION_MINOR 1
#define XNOISE_DB_CREATOR_STMT_CREATE_LASTUSED "CREATE TABLE lastused(uri text, mediatype integer);"
#define XNOISE_DB_CREATOR_STMT_CREATE_MEDIAFOLDERS "CREATE TABLE media_folders(name TEXT PRIMARY KEY);"
#define XNOISE_DB_CREATOR_STMT_CREATE_MEDIAFILES "CREATE TABLE media_files(name TEXT PRIMARY KEY);"
#define XNOISE_DB_CREATOR_STMT_CREATE_RADIO "CREATE TABLE streams (id INTEGER PRIMARY KEY, name TEXT, uri TEXT);"
#define XNOISE_DB_CREATOR_STMT_CREATE_ARTISTS "CREATE TABLE artists (id INTEGER PRIMARY KEY, name TEXT);"
#define XNOISE_DB_CREATOR_STMT_CREATE_ALBUMS "CREATE TABLE albums (id INTEGER PRIMARY KEY, artist INTEGER, name TEXT" \
", image TEXT);"
#define XNOISE_DB_CREATOR_STMT_CREATE_URIS "CREATE TABLE uris (id INTEGER PRIMARY KEY, name TEXT, type INTEGER);"
#define XNOISE_DB_CREATOR_STMT_CREATE_GENRES "CREATE TABLE genres (id integer primary key, name TEXT);"
#define XNOISE_DB_CREATOR_STMT_CREATE_ITEMS "CREATE TABLE items (id INTEGER PRIMARY KEY, tracknumber INTEGER, artis" \
"t INTEGER, album INTEGER, title TEXT, genre INTEGER, year INTEGER, uri" \
" INTEGER, mediatype INTEGER, length INTEGER, bitrate INTEGER, usertags" \
" TEXT, playcount INTEGER, rating INTEGER, lastplayTime DATETIME, addTi" \
"me DATETIME, CONSTRAINT link_uri FOREIGN KEY (uri) REFERENCES uris(id)" \
" ON DELETE CASCADE);"
#define XNOISE_DB_CREATOR_STMT_CREATE_VERSION "CREATE TABLE version (major INTEGER, minor INTEGER);"
#define XNOISE_DB_CREATOR_STMT_GET_VERSION "SELECT major FROM version;"
#define XNOISE_DB_CREATOR_STMT_FIND_TABLE "SELECT name FROM sqlite_master WHERE type='table' ORDER BY name;"
static sqlite3* xnoise_db_creator_get_db (void);
GQuark xnoise_db_error_quark (void);
static void xnoise_db_creator_check_tables (XnoiseDbCreator* self);
XnoiseDbCreator* xnoise_db_creator_new (GError** error);
XnoiseDbCreator* xnoise_db_creator_construct (GType object_type, GError** error);
GType xnoise_global_access_get_type (void);
const char* xnoise_global_access_get_settings_folder (XnoiseGlobalAccess* self);
static gboolean xnoise_db_creator_exec_stmnt_string (XnoiseDbCreator* self, const char* statement);
static void xnoise_db_creator_finalize (GObject* obj);
static void _vala_array_destroy (gpointer array, gint array_length, GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array, gint array_length, GDestroyNotify destroy_func);
static int _vala_strcmp0 (const char * str1, const char * str2);



XnoiseDbCreator* xnoise_db_creator_construct (GType object_type, GError** error) {
	GError * _inner_error_;
	XnoiseDbCreator * self;
	sqlite3* _tmp0_;
	sqlite3* _tmp1_;
	_inner_error_ = NULL;
	self = (XnoiseDbCreator*) g_object_new (object_type, NULL);
	self->priv->db = (_tmp0_ = NULL, _sqlite3_close0 (self->priv->db), _tmp0_);
	self->priv->db = (_tmp1_ = xnoise_db_creator_get_db (), _sqlite3_close0 (self->priv->db), _tmp1_);
	if (self->priv->db == NULL) {
		_inner_error_ = g_error_new_literal (XNOISE_DB_ERROR, XNOISE_DB_ERROR_FAILED, "Cannot create database.");
		{
			g_propagate_error (error, _inner_error_);
			g_object_unref (self);
			return NULL;
		}
	}
	xnoise_db_creator_check_tables (self);
	return self;
}


XnoiseDbCreator* xnoise_db_creator_new (GError** error) {
	return xnoise_db_creator_construct (XNOISE_TYPE_DB_CREATOR, error);
}


static sqlite3* xnoise_db_creator_get_db (void) {
	sqlite3* result = NULL;
	GError * _inner_error_;
	sqlite3* database;
	GFile* xnoise_home;
	GFile* _tmp0_;
	sqlite3* _tmp3_;
	sqlite3* _tmp2_ = NULL;
	char* _tmp1_;
	_inner_error_ = NULL;
	database = NULL;
	xnoise_home = g_file_new_for_path (xnoise_global_access_get_settings_folder (xnoise_global));
	xnoise_db_creator_xnoisedb = (_tmp0_ = g_file_get_child (xnoise_home, XNOISE_DB_CREATOR_DATABASE_NAME), _g_object_unref0 (xnoise_db_creator_xnoisedb), _tmp0_);
	if (!g_file_query_exists (xnoise_home, NULL)) {
		{
			g_file_make_directory_with_parents (xnoise_home, NULL, &_inner_error_);
			if (_inner_error_ != NULL) {
				goto __catch17_g_error;
			}
		}
		goto __finally17;
		__catch17_g_error:
		{
			GError * e;
			e = _inner_error_;
			_inner_error_ = NULL;
			{
				g_print ("%s\n", e->message);
				_g_error_free0 (e);
			}
		}
		__finally17:
		if (_inner_error_ != NULL) {
			_sqlite3_close0 (database);
			_g_object_unref0 (xnoise_home);
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return NULL;
		}
	}
	sqlite3_open_v2 (_tmp1_ = g_file_get_path (xnoise_db_creator_xnoisedb), &_tmp2_, SQLITE_OPEN_CREATE | SQLITE_OPEN_READWRITE, NULL);
	database = (_tmp3_ = _tmp2_, _sqlite3_close0 (database), _tmp3_);
	_g_free0 (_tmp1_);
	result = database;
	_g_object_unref0 (xnoise_home);
	return result;
}


static gint _sqlite3_exec (sqlite3* self, const char* sql, sqlite3_callback sqlite3_callback, void* sqlite3_callback_target, char** errmsg) {
	gint result = 0;
	const char* sqlite_errmsg;
	gint ec;
	g_return_val_if_fail (self != NULL, 0);
	g_return_val_if_fail (sql != NULL, 0);
	if (errmsg != NULL) {
		*errmsg = NULL;
	}
	sqlite_errmsg = NULL;
	ec = sqlite3_exec (self, sql, sqlite3_callback, sqlite3_callback_target, (char**) (&sqlite_errmsg));
	if ((errmsg) != NULL) {
		char* _tmp0_;
		*errmsg = (_tmp0_ = g_strdup (sqlite_errmsg), _g_free0 (*errmsg), _tmp0_);
	}
	sqlite3_free ((void*) sqlite_errmsg);
	result = ec;
	return result;
}


static gboolean xnoise_db_creator_exec_stmnt_string (XnoiseDbCreator* self, const char* statement) {
	gboolean result = FALSE;
	char* errormsg;
	char* _tmp2_;
	gint _tmp1_;
	char* _tmp0_ = NULL;
	g_return_val_if_fail (self != NULL, FALSE);
	g_return_val_if_fail (statement != NULL, FALSE);
	errormsg = NULL;
	if ((_tmp1_ = _sqlite3_exec (self->priv->db, statement, NULL, NULL, &_tmp0_), errormsg = (_tmp2_ = _tmp0_, _g_free0 (errormsg), _tmp2_), _tmp1_) != SQLITE_OK) {
		fprintf (stderr, "exec_stmnt_string error: %s", errormsg);
		result = FALSE;
		_g_free0 (errormsg);
		return result;
	}
	result = TRUE;
	_g_free0 (errormsg);
	return result;
}


static gint _sqlite3_get_table (sqlite3* self, const char* sql, char*** resultp, int* resultp_length1, gint* nrow, gint* ncolumn, char** errmsg) {
	gint result = 0;
	const char* sqlite_errmsg;
	gint _sqlite_resultp_size_;
	gint sqlite_resultp_length1;
	char** sqlite_resultp;
	gint ec;
	char** _tmp1_;
	gint _tmp0_;
	g_return_val_if_fail (self != NULL, 0);
	g_return_val_if_fail (sql != NULL, 0);
	if (resultp != NULL) {
		*resultp = NULL;
	}
	if (errmsg != NULL) {
		*errmsg = NULL;
	}
	sqlite_errmsg = NULL;
	sqlite_resultp = (sqlite_resultp_length1 = 0, NULL);
	ec = sqlite3_get_table (self, sql, &sqlite_resultp, nrow, ncolumn, (char**) (&sqlite_errmsg));
	*resultp = (_tmp1_ = g_new0 (char*, (_tmp0_ = ((*nrow) + 1) * (*ncolumn)) + 1), *resultp = (_vala_array_free (*resultp, *resultp_length1, (GDestroyNotify) g_free), NULL), *resultp_length1 = _tmp0_, _tmp1_);
	{
		gint entry;
		entry = 0;
		{
			gboolean _tmp2_;
			_tmp2_ = TRUE;
			while (TRUE) {
				char* _tmp3_;
				if (!_tmp2_) {
					entry++;
				}
				_tmp2_ = FALSE;
				if (!(entry < (*resultp_length1))) {
					break;
				}
				(*resultp)[entry] = (_tmp3_ = g_strdup (sqlite_resultp[entry]), _g_free0 ((*resultp)[entry]), _tmp3_);
			}
		}
	}
	sqlite3_free_table (sqlite_resultp);
	if ((errmsg) != NULL) {
		char* _tmp4_;
		*errmsg = (_tmp4_ = g_strdup (sqlite_errmsg), _g_free0 (*errmsg), _tmp4_);
	}
	sqlite3_free ((void*) sqlite_errmsg);
	result = ec;
	return result;
}


static void xnoise_db_creator_check_tables (XnoiseDbCreator* self) {
	GError * _inner_error_;
	gboolean _tmp0_ = FALSE;
	g_return_if_fail (self != NULL);
	_inner_error_ = NULL;
	if (g_file_query_exists (xnoise_db_creator_xnoisedb, NULL)) {
		_tmp0_ = self->priv->db != NULL;
	} else {
		_tmp0_ = FALSE;
	}
	if (_tmp0_) {
		gboolean db_table_exists;
		gint nrow = 0;
		gint ncolumn = 0;
		gint _resultArray_size_;
		gint resultArray_length1;
		char** resultArray;
		char* errmsg;
		char* _tmp3_;
		gint _tmp2_;
		char* _tmp1_ = NULL;
		db_table_exists = FALSE;
		resultArray = (resultArray_length1 = 0, NULL);
		errmsg = NULL;
		if ((_tmp2_ = _sqlite3_get_table (self->priv->db, XNOISE_DB_CREATOR_STMT_FIND_TABLE, &resultArray, &resultArray_length1, &nrow, &ncolumn, &_tmp1_), errmsg = (_tmp3_ = _tmp1_, _g_free0 (errmsg), _tmp3_), _tmp2_) != SQLITE_OK) {
			fprintf (stderr, "SQL error: %s\n", errmsg);
			resultArray = (_vala_array_free (resultArray, resultArray_length1, (GDestroyNotify) g_free), NULL);
			_g_free0 (errmsg);
			return;
		}
		{
			gint offset;
			offset = 1;
			{
				gboolean _tmp4_;
				_tmp4_ = TRUE;
				while (TRUE) {
					gboolean _tmp5_ = FALSE;
					if (!_tmp4_) {
						offset++;
					}
					_tmp4_ = FALSE;
					if (offset < (nrow + 1)) {
						_tmp5_ = db_table_exists == FALSE;
					} else {
						_tmp5_ = FALSE;
					}
					if (!_tmp5_) {
						break;
					}
					{
						gint j;
						j = offset * ncolumn;
						{
							gboolean _tmp6_;
							_tmp6_ = TRUE;
							while (TRUE) {
								if (!_tmp6_) {
									j++;
								}
								_tmp6_ = FALSE;
								if (!(j < ((offset + 1) * ncolumn))) {
									break;
								}
								if (_vala_strcmp0 (resultArray[j], "version") == 0) {
									db_table_exists = TRUE;
									break;
								}
							}
						}
					}
				}
			}
		}
		if (db_table_exists == TRUE) {
			char* _tmp9_;
			gint _tmp8_;
			char* _tmp7_ = NULL;
			char* major;
			char* _tmp10_;
			gboolean _tmp11_;
			if ((_tmp8_ = _sqlite3_get_table (self->priv->db, XNOISE_DB_CREATOR_STMT_GET_VERSION, &resultArray, &resultArray_length1, &nrow, &ncolumn, &_tmp7_), errmsg = (_tmp9_ = _tmp7_, _g_free0 (errmsg), _tmp9_), _tmp8_) != SQLITE_OK) {
				fprintf (stderr, "SQL error: %s\n", errmsg);
				resultArray = (_vala_array_free (resultArray, resultArray_length1, (GDestroyNotify) g_free), NULL);
				_g_free0 (errmsg);
				return;
			}
			major = g_strdup (resultArray[1]);
			if ((_tmp11_ = _vala_strcmp0 (major, _tmp10_ = g_strdup_printf ("%d", XNOISE_DB_CREATOR_DB_VERSION_MAJOR)) != 0, _g_free0 (_tmp10_), _tmp11_)) {
				sqlite3* _tmp12_;
				g_print ("Wrong major db version\n");
				self->priv->db = (_tmp12_ = NULL, _sqlite3_close0 (self->priv->db), _tmp12_);
				{
					g_file_delete (xnoise_db_creator_xnoisedb, NULL, &_inner_error_);
					if (_inner_error_ != NULL) {
						goto __catch18_g_error;
					}
				}
				goto __finally18;
				__catch18_g_error:
				{
					GError * e;
					e = _inner_error_;
					_inner_error_ = NULL;
					{
						g_print ("%s\n", e->message);
						_g_error_free0 (e);
					}
				}
				__finally18:
				if (_inner_error_ != NULL) {
					_g_free0 (major);
					resultArray = (_vala_array_free (resultArray, resultArray_length1, (GDestroyNotify) g_free), NULL);
					_g_free0 (errmsg);
					g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
					g_clear_error (&_inner_error_);
					return;
				}
			}
			_g_free0 (major);
		} else {
			char* _tmp13_;
			if (!xnoise_db_creator_exec_stmnt_string (self, XNOISE_DB_CREATOR_STMT_CREATE_LASTUSED)) {
				resultArray = (_vala_array_free (resultArray, resultArray_length1, (GDestroyNotify) g_free), NULL);
				_g_free0 (errmsg);
				return;
			}
			if (!xnoise_db_creator_exec_stmnt_string (self, XNOISE_DB_CREATOR_STMT_CREATE_MEDIAFOLDERS)) {
				resultArray = (_vala_array_free (resultArray, resultArray_length1, (GDestroyNotify) g_free), NULL);
				_g_free0 (errmsg);
				return;
			}
			if (!xnoise_db_creator_exec_stmnt_string (self, XNOISE_DB_CREATOR_STMT_CREATE_MEDIAFILES)) {
				resultArray = (_vala_array_free (resultArray, resultArray_length1, (GDestroyNotify) g_free), NULL);
				_g_free0 (errmsg);
				return;
			}
			if (!xnoise_db_creator_exec_stmnt_string (self, XNOISE_DB_CREATOR_STMT_CREATE_RADIO)) {
				resultArray = (_vala_array_free (resultArray, resultArray_length1, (GDestroyNotify) g_free), NULL);
				_g_free0 (errmsg);
				return;
			}
			if (!xnoise_db_creator_exec_stmnt_string (self, XNOISE_DB_CREATOR_STMT_CREATE_ARTISTS)) {
				resultArray = (_vala_array_free (resultArray, resultArray_length1, (GDestroyNotify) g_free), NULL);
				_g_free0 (errmsg);
				return;
			}
			if (!xnoise_db_creator_exec_stmnt_string (self, XNOISE_DB_CREATOR_STMT_CREATE_ALBUMS)) {
				resultArray = (_vala_array_free (resultArray, resultArray_length1, (GDestroyNotify) g_free), NULL);
				_g_free0 (errmsg);
				return;
			}
			if (!xnoise_db_creator_exec_stmnt_string (self, XNOISE_DB_CREATOR_STMT_CREATE_URIS)) {
				resultArray = (_vala_array_free (resultArray, resultArray_length1, (GDestroyNotify) g_free), NULL);
				_g_free0 (errmsg);
				return;
			}
			if (!xnoise_db_creator_exec_stmnt_string (self, XNOISE_DB_CREATOR_STMT_CREATE_ITEMS)) {
				resultArray = (_vala_array_free (resultArray, resultArray_length1, (GDestroyNotify) g_free), NULL);
				_g_free0 (errmsg);
				return;
			}
			if (!xnoise_db_creator_exec_stmnt_string (self, XNOISE_DB_CREATOR_STMT_CREATE_GENRES)) {
				resultArray = (_vala_array_free (resultArray, resultArray_length1, (GDestroyNotify) g_free), NULL);
				_g_free0 (errmsg);
				return;
			}
			if (!xnoise_db_creator_exec_stmnt_string (self, XNOISE_DB_CREATOR_STMT_CREATE_VERSION)) {
				resultArray = (_vala_array_free (resultArray, resultArray_length1, (GDestroyNotify) g_free), NULL);
				_g_free0 (errmsg);
				return;
			}
			xnoise_db_creator_exec_stmnt_string (self, _tmp13_ = g_strdup_printf ("INSERT INTO version (major, minor) VALUES (%d, %d);", XNOISE_DB_CREATOR_DB_VERSION_MAJOR, XNOISE_DB_CREATOR_DB_VERSION_MINOR));
			_g_free0 (_tmp13_);
		}
		resultArray = (_vala_array_free (resultArray, resultArray_length1, (GDestroyNotify) g_free), NULL);
		_g_free0 (errmsg);
	} else {
		g_print ("Could not create or open database.\n");
	}
}


static void xnoise_db_creator_class_init (XnoiseDbCreatorClass * klass) {
	xnoise_db_creator_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (XnoiseDbCreatorPrivate));
	G_OBJECT_CLASS (klass)->finalize = xnoise_db_creator_finalize;
}


static void xnoise_db_creator_instance_init (XnoiseDbCreator * self) {
	self->priv = XNOISE_DB_CREATOR_GET_PRIVATE (self);
}


static void xnoise_db_creator_finalize (GObject* obj) {
	XnoiseDbCreator * self;
	self = XNOISE_DB_CREATOR (obj);
	_sqlite3_close0 (self->priv->db);
	G_OBJECT_CLASS (xnoise_db_creator_parent_class)->finalize (obj);
}


GType xnoise_db_creator_get_type (void) {
	static volatile gsize xnoise_db_creator_type_id__volatile = 0;
	if (g_once_init_enter (&xnoise_db_creator_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (XnoiseDbCreatorClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) xnoise_db_creator_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (XnoiseDbCreator), 0, (GInstanceInitFunc) xnoise_db_creator_instance_init, NULL };
		GType xnoise_db_creator_type_id;
		xnoise_db_creator_type_id = g_type_register_static (G_TYPE_OBJECT, "XnoiseDbCreator", &g_define_type_info, 0);
		g_once_init_leave (&xnoise_db_creator_type_id__volatile, xnoise_db_creator_type_id);
	}
	return xnoise_db_creator_type_id__volatile;
}


static void _vala_array_destroy (gpointer array, gint array_length, GDestroyNotify destroy_func) {
	if ((array != NULL) && (destroy_func != NULL)) {
		int i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}


static void _vala_array_free (gpointer array, gint array_length, GDestroyNotify destroy_func) {
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}


static int _vala_strcmp0 (const char * str1, const char * str2) {
	if (str1 == NULL) {
		return -(str1 != str2);
	}
	if (str2 == NULL) {
		return str1 != str2;
	}
	return strcmp (str1, str2);
}




